/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Lib.xs. Do not edit this file, edit Lib.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Lib.xs"
#ifdef WIN32
#undef read
#undef write
#else
#include <sys/time.h>
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <event.h>
#include <assert.h>

/* shut up a compiler warning: ppport.h redefines
 * PERL_UNUSED_DECL already defined in perl.h */
#ifdef PERL_UNUSED_DECL
#   undef PERL_UNUSED_DECL
#endif

#include "ppport.h"

#include "const-c.inc"

#define CALLBACK_CAST	(void (*)(int, short, void*))
#define to_perlio(sv)	IoIFP(sv_2io(sv))
#define is_event(sv)	(SvTYPE(sv) == SVt_RV && sv_derived_from(sv, "Event::Lib::base"))

#define	EV_TRACE	    0x20

#define EVf_EVENT_SET	    0x00000001
#define EVf_PRIO_SET	    0x00000002
#define EVf_EVENT_DELETED   0x00000004
#define EVf_EVENT_TRACED    0x00000010	

#define EvFLAGS(ev)	    (ev->flags)

#define EvEVENT_SET(ev)		(EvFLAGS(ev) & EVf_EVENT_SET)
#define EvEVENT_SET_on(ev)	EvFLAGS(ev) |= EVf_EVENT_SET
#define EvEVENT_SET_off(ev)	EvFLAGS(ev) &= ~EVf_EVENT_SET

#define EvPRIO_SET(ev)		(EvFLAGS(ev) & EVf_PRIO_SET)
#define EvPRIO_SET_on(ev)	EvFLAGS(ev) |= EVf_PRIO_SET
#define EvPRIO_SET_off(ev)	EvFLAGS(ev) &= ~EVf_PRIO_SET

#define EvEVENT_TRACED(ev)	(EvFLAGS(ev) & EVf_EVENT_TRACED)
#define EvEVENT_TRACED_on(ev)	EvFLAGS(ev) |= EVf_EVENT_TRACED
#define EvEVENT_TRACED_off(ev)	EvFLAGS(ev) &= ~EVf_EVENT_TRACED

#define IN_GLOBAL_CLEANUP PL_dirty

SV * do_exception_handler (pTHX_ short event, SV *ev, SV *err);
void do_callback (int fd, short event, SV *ev);

struct event_args {
    struct event    ev;		/* the event that was triggered */
    SV		    *io;	/* the associated filehandle */
    CV		    *func;	/* the Perl callback to handle event */
    int		    num;	/* number of additional args */
    int		    buckets;	/* number of allocated slots for args (buckets >= args) */
    SV		    **args;	/* additional args */
    const char	    *type;	/* so we know into which class to bless in do_callback */
    CV		    *trapper;	/* exception handler */
    int		    evtype;	/* what kind of event or signal; always 0 for timer events */
    int		    priority;	/* what priority */
    int		    flags;	/* EVf_EVENT_SET, EVf_PRIO_SET */
#ifdef EVENT_LIB_DEBUG
    SV		    *loc;	/* location information: where was event created */
    char	    *cbname;	/* name of the callback */
#endif
};


CV *DEFAULT_EXCEPTION_HANDLER = NULL;

/* The following flag is set when we are inside a callback.  It is to prevent
 * incrementing of the reference-count of a an event when it is re-added from
 * inside its handler.  However, in order to allow something like that:
 *
 *  sub event_handler {
 *	my $ev = shift;
 *	...
 *	timer_new(...)->add(1);
 *  }
 *  
 * we additionally have to check if the currently executing event is to be
 * re-added (in this case: no refcnt++) or if another event was added (in this
 * case: refcnt++). 
 *
 * Therefore we have to store the address of the currently executing event in
 * IN_CALLBACK and a simply true/false flag wont do.
 *
 * If we don't do that, we get a refcount-to-infinity problem because
 * do_callback wont decrement the refcnt of an event when it's pending. And i
 * is certainly pending when it has been readded from within its handler.
 */
struct event_args *IN_CALLBACK = NULL;
#define ENTER_callback(ev)	IN_CALLBACK = ev
#define LEAVE_callback		IN_CALLBACK = NULL
#define RUNNING_callback(ev)	((ev) == IN_CALLBACK)

#include "event_debug.h"

void free_args (struct event_args *args) {
    
    register int i;

    if (args->io) {
	SvREFCNT_dec(args->io);
    }
   
    SvREFCNT_dec(args->func);
    for (i = 0; i < args->num; ++i)
	SvREFCNT_dec(args->args[i]);

    Safefree(args->args);

    if (args->trapper != DEFAULT_EXCEPTION_HANDLER)
	SvREFCNT_dec(args->trapper);

#ifdef EVENT_LIB_DEBUG
    SvREFCNT_dec(args->loc);
    Safefree(args->cbname);
#endif
    Safefree(args);
}

void refresh_event (struct event_args *args, char *class) {
    SV *sv = newSV(0);
    sv_setref_pv(sv, class, (void*)args);
    args->ev.ev_arg = (void*)sv;
}

SV * do_exception_handler (pTHX_ short event, SV *ev, SV *err) {
    register int i;
    int count;
    struct event_args *args = (struct event_args*)SvIV(SvRV(ev));

    dSP;
    
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    
    EXTEND(SP, event ? args->num + 3 : 2);
    PUSHs(ev);
    
    PUSHs(sv_2mortal(err));

    if (event) {
	PUSHs(sv_2mortal(newSViv(event)));
	for (i = 0; i < args->num; i++)
	    PUSHs(args->args[i]);
    }
    

    PUTBACK;
    count = call_sv((SV*)args->trapper, G_SCALAR|G_EVAL);
    
    if (SvTRUE(ERRSV))
	croak(Nullch);
    
    SPAGAIN;
    
    if (count != 1)
	ev = &PL_sv_undef;
    else
	ev = POPs;
    
    PUTBACK;
    FREETMPS;
    LEAVE;

    return ev;
}

void do_callback (int fd, short event, SV *ev) {
    register int i;
    struct event_args *args = (struct event_args*)SvIV(SvRV(ev));
    dSP;

    DEBUG_trace(args);
    
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    
    EXTEND(SP, args->num + 2);

    PUSHs(ev);
    PUSHs(sv_2mortal(newSViv(event)));

    for (i = 0; i < args->num; ++i)
	PUSHs(args->args[i]);

    /* !!! START OF CALLBACK SECTION !!! */
    ENTER_callback(args);
    
    PUTBACK;
    call_sv((SV*)args->func, G_VOID|G_DISCARD|G_EVAL);
    if (SvTRUE(ERRSV))
	do_exception_handler(aTHX_ event, ev, newSVsv(ERRSV));
    
    LEAVE_callback;
    /* !!! END OF CALLBACK SECTION !!! */

    /* It's possible that the event was manually deleted inside the
     * handlers, in which case the ref-cnt has already been decremented */
    if (!event_pending(&args->ev, event, NULL)) {
	EvEVENT_SET_off(args);
    	SvREFCNT_dec((SV*)args->ev.ev_arg);
	if (SvOK(ev))
	    DEBUG_trace(args);
    }

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}


#ifdef WIN32
#define THEINLINE __forceinline
#else
#define THEINLINE inline
#endif

THEINLINE void make_timeval (struct timeval *tv, double t) {
    tv->tv_sec = (long)t;
    tv->tv_usec = (t - (long)t) * 1e6f;
}

THEINLINE double delta_timeval (struct timeval *t1, struct timeval *t2) {
    double t1t = t1->tv_sec + (double)t1->tv_usec / 1e6f;
    double t2t = t2->tv_sec + (double)t2->tv_usec / 1e6f; 
    return t2t - t1t;
}

#ifdef HAVE_LOG_CALLBACKS
unsigned int LOG_LEVEL = _EVENT_LOG_ERR;
static const char* str[] = { "debug", "msg", "warn", "err", "???" };

void log_cb (int sev, const char *msg) {
    if (sev >= LOG_LEVEL) {
	if (sev > _EVENT_LOG_ERR) 
	    sev = _EVENT_LOG_ERR + 1;
	PerlIO_printf(PerlIO_stderr(), "[%s (pid=%i)] %s\n", str[sev], getpid() , msg);
    }
}
#endif

bool EVENT_LOOP_RUNNING = FALSE;
int  EVENT_INIT_DONE = -1;  /* we use the pid here */

#define event_do_init()	    \
{\
    int _pid_ = SvIV(get_sv("$", FALSE)); \
    if (!EVENT_INIT_DONE  || EVENT_INIT_DONE != _pid_) {\
	event_init();	\
	DEBUG_init_pending(aTHX);   \
	DEBUG_init_count(aTHX);	    \
	EVENT_INIT_DONE = _pid_;    \
	IN_CALLBACK = 0;	    \
    }\
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 282 "Lib.c"

/* INCLUDE:  Including 'const-xs.inc' from 'Lib.xs' */


XS(XS_Event__Lib_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::constant", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 312 "Lib.c"
	SV *	sv = ST(0);
	const char *	s = SvPV(sv, len);
#line 18 "const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Event::Lib macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Event::Lib macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Event::Lib macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 389 "Lib.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'Lib.xs' from 'const-xs.inc' */


XS(XS_Event__Lib__default_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__default_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 286 "Lib.xs"
{
    sv_setsv(ERRSV, ST(1));
    croak(Nullch);
    PERL_UNUSED_VAR(items); /* to silence the compiler */
}
#line 415 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib_event_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_init", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 296 "Lib.xs"
{
    event_do_init();
}
#line 437 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib_event_get_method); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_get_method)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = event_get_method();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_event_get_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_get_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = event_get_version();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_event_log_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_log_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_log_level", "level");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	level = (unsigned int)SvUV(ST(0));
#line 314 "Lib.xs"
{
#ifdef HAVE_LOG_CALLBACKS
    LOG_LEVEL = level;
#endif
}
#line 508 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib_event_register_except_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_register_except_handler)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_register_except_handler", "func");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	func = ST(0);
#line 324 "Lib.xs"
{
    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Argument to event_register_except_handler must be code-reference");
    DEFAULT_EXCEPTION_HANDLER = (CV*)SvRV(func);
}
#line 533 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib_event_priority_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_priority_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_priority_init", "nump");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nump = (int)SvIV(ST(0));
	int	RETVAL;
	dXSTARG;
#line 335 "Lib.xs"
{
    event_do_init();
#ifdef HAVE_PRIORITIES
    RETVAL = event_priority_init(nump);
#else
    RETVAL = 1;
#endif
}
#line 563 "Lib.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_event_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_new", "io, event, func, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	io = ST(0);
	short	event = (short)SvIV(ST(1));
	SV *	func = ST(2);
#line 352 "Lib.xs"
    static char *CLASS = "Event::Lib::event";
    struct event_args *args;
#line 588 "Lib.c"
	struct event_args *	RETVAL;
#line 355 "Lib.xs"
{
    register int i;

    if (GIMME_V == G_VOID)
	XSRETURN_UNDEF;

    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Third argument to event_new must be code-reference");

    event_do_init();

    New(0, args, 1, struct event_args); 

    args->io = io;
    args->func = (CV*)SvRV(func);
    args->type = CLASS;
    args->trapper = DEFAULT_EXCEPTION_HANDLER;
    args->evtype = event;
    args->priority = -1;

    EvFLAGS(args) = 0;

    DEBUG_store_location(aTHX_ args);
#ifdef EVENT_LIB_DEBUG
    /* is it a traced event? */
    if (event & EV_TRACE) {
	EvFLAGS(args) |= EVf_EVENT_TRACED;
	event &= ~EV_TRACE;
    }
#endif

    SvREFCNT_inc(args->io);
    SvREFCNT_inc(args->func);

    if ((args->buckets = args->num = items - 3)) 
	New(0, args->args, args->buckets, SV*);
    else
	args->args = NULL;

    for (i = 0; i < args->num; i++) {
	args->args[i] = ST(i+3);
	SvREFCNT_inc(args->args[i]);
    }

    RETVAL = args;
}
#line 637 "Lib.c"
#line 404 "Lib.xs"
    DEBUG_inc_count(EVENT_NEW_COUNT);
#line 640 "Lib.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), CLASS, (void*)RETVAL );


#line 406 "Lib.xs"
    DEBUG_record_allo(aTHX_ ST(0));
#line 647 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_signal_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_signal_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::signal_new", "signal, func, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	signal = (int)SvIV(ST(0));
	SV *	func = ST(1);
#line 413 "Lib.xs"
    static char *CLASS = "Event::Lib::signal";
    struct event_args *args;
#line 670 "Lib.c"
	struct event_args *	RETVAL;
#line 416 "Lib.xs"
{
    register int i;

    if (GIMME_V == G_VOID)
	XSRETURN_UNDEF;

    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Second argument to event_new must be code-reference");

    event_do_init();

    New(0, args, 1, struct event_args);

    args->io = NULL;
    args->func = (CV*)SvRV(func);
    args->type = CLASS;
    args->trapper = DEFAULT_EXCEPTION_HANDLER;
    args->evtype = signal;
    args->priority = -1;

    EvFLAGS(args) = 0;

    DEBUG_store_location(aTHX_ args);

    SvREFCNT_inc(args->func);

    if ((args->buckets = args->num = items - 2))
	New(0, args->args, args->buckets, SV*);
    else
	args->args = NULL;

    for (i = 0; i < args->num; i++) {
	args->args[i] = ST(i+2);
	SvREFCNT_inc(args->args[i]);
    }

    RETVAL = args;
}
#line 711 "Lib.c"
#line 457 "Lib.xs"
    DEBUG_inc_count(SIGNAL_NEW_COUNT);
#line 714 "Lib.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), CLASS, (void*)RETVAL );


#line 459 "Lib.xs"
    DEBUG_record_allo(aTHX_ ST(0));
#line 721 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_timer_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_timer_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::timer_new", "func, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	func = ST(0);
#line 465 "Lib.xs"
    static char *CLASS = "Event::Lib::timer";
    struct event_args *args;
#line 743 "Lib.c"
	struct event_args *	RETVAL;
#line 468 "Lib.xs"
{
    register int i;

    if (GIMME_V == G_VOID)
	XSRETURN_UNDEF;

    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("First argument to timer_new must be code-reference");

    event_do_init();

    New(0, args, 1, struct event_args);

    args->io = NULL;
    args->func = (CV*)SvRV(func);
    args->type = CLASS;
    args->trapper = DEFAULT_EXCEPTION_HANDLER;
    args->evtype = 0;
    args->priority = -1;

    EvFLAGS(args) = 0;

    DEBUG_store_location(aTHX_ args);

    SvREFCNT_inc(args->func);

    if ((args->buckets = args->num = items - 1))
	New(0, args->args, args->buckets, SV*);
    else
	args->args = NULL;

    for (i = 0; i < args->num; i++) {
	    args->args[i] = ST(i+1);
	    SvREFCNT_inc(args->args[i]);
    }

    RETVAL = args;
}
#line 784 "Lib.c"
#line 509 "Lib.xs"
    DEBUG_inc_count(TIMER_NEW_COUNT);
#line 787 "Lib.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), CLASS, (void*)RETVAL );


#line 511 "Lib.xs"
    DEBUG_record_allo(aTHX_ ST(0));
#line 794 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_event_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_add", "args, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event_add() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 517 "Lib.xs"
{
#define FORMAT		"[event_add] ev = 0x%p (%s)\n  (from %s)\n  (by %s:%d)"

    struct timeval tv = { 1, 0 };
    int time_given = 0;
    int exception_flag = 0;

    DEBUG_trace(args);

    if (!EvEVENT_SET(args)) {
	DEBUG_warn(FORMAT, args, args->type, SvPV_nolen(args->loc),
		   CopFILE(PL_curcop) ? CopFILE(PL_curcop) : "unknown",
		   CopLINE(PL_curcop) ? CopLINE(PL_curcop) : -1);
	if (strEQ(args->type, "Event::Lib::event")) {
	    PerlIO *io = to_perlio(args->io);
	    int fd = io ? PerlIO_fileno(to_perlio(args->io)) : -1;
	    event_set(&args->ev, fd, (short)args->evtype, CALLBACK_CAST do_callback, (void*)ST(0));
	    if (fd == -1) {
		/* We always call event_set even when fd is potentially -1.
		 * This is only so that the exception handler is called with a
		 * proper event. However, we don't set the EvEVENT_SET flag so
		 * that this event will again be event_set()ed next time. */
		errno = EBADF;
		exception_flag = -args->evtype;
		goto force_failure;
	    }
	}
	else if (strEQ(args->type, "Event::Lib::signal")) {
	    signal_set(&args->ev, args->evtype, CALLBACK_CAST do_callback, (void*)ST(0));
	    exception_flag = -args->evtype;
	}
	else if (strEQ(args->type, "Event::Lib::timer")) {
	    evtimer_set(&args->ev, CALLBACK_CAST do_callback, (void*)ST(0));
	    exception_flag = -EV_TIMEOUT;
	}
	EvEVENT_SET_on(args);
	DEBUG_trace(args);
    } else if (event_pending(&args->ev, EV_TIMEOUT|EV_READ|EV_WRITE|EV_SIGNAL, NULL))
	croak("Attempt to add event a second time");
#ifdef HAVE_PRIORITIES
    if (!EvPRIO_SET(args)) {
	event_priority_set(&args->ev, args->priority);
	EvPRIO_SET_on(args);
    }
#endif

    if (sv_derived_from(ST(0), "Event::Lib::timer") && items == 1)
	time_given = 1;

    if (items > 1) {

	/* add(0) should behave like add() */
	if (SvIOK(ST(1)) && SvIV(ST(1)) == 0)
	    goto skip;

	make_timeval(&tv, SvNV(ST(1)));
	time_given = 1;
    }

    skip:
    if (event_add(&args->ev, time_given ? &tv : NULL) == 0) {

	/* Are we trying to re-add the currently executing event? */
	if (RUNNING_callback(args)) {
	    XSRETURN(1);
	}

	/* Nope, it's another event so it's ok to increment the ref-cnt */
	SvREFCNT_inc((SV*)args->ev.ev_arg);
	DEBUG_record_event(aTHX_ ST(0));
	DEBUG_trace(args);
	XSRETURN(1);
    }

    force_failure:
    /* event_add failed :-( */
    do_exception_handler(aTHX_ exception_flag, ST(0), newSVpvn("Couldn't add event", 18));
}	
#line 899 "Lib.c"
#line 595 "Lib.xs"
#line 901 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_event_free); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_free)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_free", "args, flags = 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;
	int	flags;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event_free() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 602 "Lib.xs"
{
    if (!flags)
	warn("You should not call event_free unless it's an emergency");

    event_del(&args->ev);
    free_args(args);

    /* unbless referent:
     * this is crucial because access to the object after it
     * has been freed could lead to segfaults */
    SvFLAGS(SvRV(ST(0))) &= ~SVs_OBJECT;
}
#line 947 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib_event_mainloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_mainloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_mainloop", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 619 "Lib.xs"
{
    int ret;
    if (EVENT_LOOP_RUNNING) {
	warn("Attempt to trigger another loop while the main-loop is already running");
	return;
    }

    EVENT_LOOP_RUNNING = TRUE;
    ret = event_dispatch();
    EVENT_LOOP_RUNNING = FALSE;
    if (ret == 1)
	XSRETURN_YES;
    else
	XSRETURN_NO;
}
#line 981 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib_event_one_loop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_one_loop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 639 "Lib.xs"
{
    if (EVENT_LOOP_RUNNING) {
	warn("Attempt to trigger another loop while the main-loop is already running");
	return;
    }

    if (items > 0) {
	struct timeval tv;
	make_timeval(&tv, SvNV(ST(0)));
	event_loopexit(&tv);
    }
    event_loop(EVLOOP_ONCE);
}
#line 1011 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib_event_one_nbloop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib_event_one_nbloop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event_one_nbloop", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 657 "Lib.xs"
{
    event_loop(EVLOOP_NONBLOCK);
}
#line 1033 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__base_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::remove", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::remove() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 667 "Lib.xs"
{
    /*******************************************************
     * !! THIS FUNCTION IS OVERRIDDEN FOR SIGNAL-EVENTS !! *
     *******************************************************/

    DEBUG_trace(args);

    if (!EvEVENT_SET(args)) {
	DEBUG_trace(args);
	XSRETURN_NO;
    }

    if (event_pending(&args->ev, EV_TIMEOUT|EV_READ|EV_WRITE, NULL) 
	&& event_del(&args->ev) == 0) {
	EvEVENT_SET_off(args);

	/* when called from inside a callback, we defer this
	 * SvREFCNT_dec. do_callback will do it for us. This
	 * is to prevent that the event is already DESTROYed
	 * from inside the handler which cannot be detected
	 * in do_callback. */
	if (!RUNNING_callback(args))
	    /* We are not using ST(0) here but instead the loop-back
	     * object stored inside the event because this is what is
	     * decremented in do_callback and incremented in event_add */
	    SvREFCNT_dec((SV*)args->ev.ev_arg);

	DEBUG_trace(args);
    }

    DEBUG_trace(args);
    XSRETURN_NO;
}
#line 1093 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__base_except_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_except_handler)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::except_handler", "args, func");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;
	SV *	func = ST(1);

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::except_handler() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 706 "Lib.xs"
{
    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Argument to event_register_except_handler must be code-reference");
    args->trapper = (CV*)SvRV(func);
    SvREFCNT_inc(args->trapper);
    XSRETURN(1);
}
#line 1128 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__base_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::callback", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::callback() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 718 "Lib.xs"
{
    ST(0) = sv_2mortal(newRV_inc((SV*)args->func));
    XSRETURN(1);
}
#line 1159 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib__base_args); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_args)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::args", "args, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::args() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 727 "Lib.xs"
{
    register int i;

    if (items == 1) {
	/* arguments are merely queried */
	U32 gimme = GIMME_V;
	switch (gimme) {
	    case G_VOID:
		return;
	    case G_SCALAR:
		ST(0) = sv_2mortal(newSViv(args->num));
		XSRETURN(1);
	    case G_ARRAY:
		EXTEND(SP, args->num);
		for (i = 0; i < args->num; ++i)
		    ST(i) = args->args[i];
		XSRETURN(args->num);
	}
    }

    /* items > 1: arguments are replaced */

    for (i = 0; i < args->num; ++i)
	SvREFCNT_dec(args->args[i]);
    if (items - 1 > args->buckets) {
	args->buckets = items - 1;
	Renew(args->args, args->buckets, SV*);
    }
    args->num = items - 1;
    for (i = 0; i < args->num; ++i) {
	args->args[i] = ST(i+1);
	SvREFCNT_inc(args->args[i]);
    }
}	
#line 1220 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib__base_args_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_args_del)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::args_del", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::args_del() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 766 "Lib.xs"
{
    register int i;
    for (i = 0; i < args->num; ++i)
	SvREFCNT_dec(args->args[i]);
    args->num = 0;
}
#line 1253 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__base_set_priority); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_set_priority)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::set_priority", "args, prio");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;
	int	prio = (int)SvIV(ST(1));

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::set_priority() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 778 "Lib.xs"
{
    args->priority = prio;
}
#line 1284 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__base_trace); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__base_trace)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::base::trace", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::trace() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 786 "Lib.xs"
{
    EvEVENT_TRACED_on(args);
    XSRETURN(1);
}
#line 1315 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__event_fh); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__event_fh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event::fh", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event::fh() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 797 "Lib.xs"
{
    DEBUG_trace(args);
    ST(0) = args->io;
    XSRETURN(1);
}
#line 1347 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib__event_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__event_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event::pending", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event::pending() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 807 "Lib.xs"
{
    struct timeval tv = { 0, 0 }, now;
    SV *sv;

    gettimeofday(&now, NULL);

    if (!event_pending(&args->ev, EV_READ|EV_WRITE|EV_TIMEOUT, &tv))
	XSRETURN_NO;

    if (tv.tv_sec == 0 && tv.tv_usec == 0)
	sv = newSVpvn("0 but true", 10);
    else 
	sv = newSVnv(fabs(delta_timeval(&now, &tv)));

    ST(0) = sv_2mortal(sv);
    XSRETURN(1);
}
#line 1391 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib__event_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__event_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::event::DESTROY", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event::DESTROY() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 829 "Lib.xs"
{
    DEBUG_trace(args);
    DEBUG_warn("[DESTROY]   ev = 0x%p (%s)\n  (from %s)", args, args->type, SvPV_nolen(args->loc));

    /* We get to DESTROY a pending event:
     * This can happen when an event object was explictely 
     * reassigned to or when undef() was called on it.
     * We DO NOT delete and free it. Instead we issue a warning
     * disassociate this event from ST(0) and keep it pending */
    if (!IN_GLOBAL_CLEANUP && 
	EvEVENT_SET(args) && event_pending(&args->ev, EV_READ|EV_WRITE, NULL)) {
	if (ckWARN(WARN_MISC))
	    warn("Explicit undef() of or reassignment to pending event");
	refresh_event(args, HvNAME(SvSTASH(SvRV(ST(0)))));
	XSRETURN_EMPTY;
    }

    DEBUG_delete_event(aTHX_ ST(0));
    DEBUG_delete_allo(aTHX_ ST(0));

    free_args(args);
}
#line 1440 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__signal_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__signal_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::signal::pending", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::signal::pending() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 859 "Lib.xs"
{
    struct timeval tv = { 0, 0 }, now;
    SV *sv;

    DEBUG_trace(args);

    gettimeofday(&now, NULL);

    if (!signal_pending(&args->ev, &tv))
	XSRETURN_NO;

    if (tv.tv_sec == 0 && tv.tv_usec == 0)
	sv = newSVpvn("0 but true", 10);
    else 
	sv = newSVnv(fabs(delta_timeval(&now, &tv)));

    ST(0) = sv_2mortal(sv);
    XSRETURN(1);
}
#line 1486 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib__signal_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__signal_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::signal::remove", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::signal::remove() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 883 "Lib.xs"
{

    /******************************************
     * !! OVERRIDING Event::Lib::base::remove !! *
     ******************************************/

    /* XXX This works for the test-suite but who knows.
     * XXX The culprit is that signal-events behave
     * XXX differently: They are per default persistent.
     * XXX Still, additional logic may be required here. */
    if (event_del(&args->ev) == 0) {
	EvEVENT_SET_off(args);
	XSRETURN_YES;
    }

    XSRETURN_NO;
}
#line 1530 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__signal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__signal_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::signal::DESTROY", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::signal::DESTROY() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 905 "Lib.xs"
{

    DEBUG_warn("[DESTROY]   ev = 0x%p (%s)\n  (from %s)", args, args->type, SvPV_nolen(args->loc));
    DEBUG_trace(args);

    /* We get to DESTROY a pending event:
     * This can happen when an event object was explictely 
     * reassigned to or when undef() was called on it.
     * We DO NOT delete and free it. Instead we issue a warning
     * disassociate this event from ST(0) and keep it pending */
    if (!IN_GLOBAL_CLEANUP &&
	EvEVENT_SET(args) && signal_pending(&args->ev, NULL)) {
	if (ckWARN_d(WARN_MISC))
	    warn("Explicit undef() of or reassignment to pending event");
	refresh_event(args, HvNAME(SvSTASH(SvRV(ST(0)))));
	XSRETURN_EMPTY;
    }

    DEBUG_delete_event(aTHX_ ST(0));
    DEBUG_delete_allo(aTHX_ ST(0));

    free_args(args);
}
#line 1580 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__timer_pending); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__timer_pending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::timer::pending", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::timer::pending() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 936 "Lib.xs"
{
    struct timeval tv = { 0, 0 }, now;
    SV *sv;

    gettimeofday(&now, NULL);

    if (!evtimer_pending(&args->ev, &tv))
	XSRETURN_NO;

    if (tv.tv_sec == 0 && tv.tv_usec == 0)
	sv = newSVpvn("0 but true", 10);
    else 
	sv = newSVnv(fabs(delta_timeval(&now, &tv)));

    ST(0) = sv_2mortal(sv);
    XSRETURN(1);
}
#line 1624 "Lib.c"
    }
    XSRETURN(1);
}


XS(XS_Event__Lib__timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__timer_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::timer::DESTROY", "args");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::timer::DESTROY() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    };
#line 958 "Lib.xs"
{
    DEBUG_warn("[DESTROY]   ev = 0x%p (%s)\n  (from %s)", args, args->type, SvPV_nolen(args->loc));
    DEBUG_trace(args);

    /* We get to DESTROY a pending event:
     * This can happen when an event object was explictely 
     * reassigned to or when undef() was called on it.
     * We DO NOT delete and free it. Instead we issue a warning
     * disassociate this event from ST(0) and keep it pending */
    if (!IN_GLOBAL_CLEANUP &&
	EvEVENT_SET(args) && evtimer_pending(&args->ev, NULL)) {
	if (ckWARN(WARN_MISC))
	    warn("Explicit undef() of or reassignment to pending event");
	refresh_event(args, HvNAME(SvSTASH(SvRV(ST(0)))));
	XSRETURN_EMPTY;
    }

    DEBUG_delete_event(aTHX_ ST(0));
    DEBUG_delete_allo(aTHX_ ST(0));

    free_args(args);
}
#line 1673 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__Debug_get_pending_events); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__Debug_get_pending_events)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::Debug::get_pending_events", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 986 "Lib.xs"
{
    DEBUG_get_pending_events(aTHX);
}
#line 1695 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__Debug_dump_pending_events); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__Debug_dump_pending_events)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::Debug::dump_pending_events", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 993 "Lib.xs"
{
    DEBUG_dump_pending_events(aTHX);
}
#line 1717 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__Debug_dump_allocated_events); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__Debug_dump_allocated_events)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::Debug::dump_allocated_events", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1000 "Lib.xs"
{
    DEBUG_dump_allocated(aTHX);
}
#line 1739 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Event__Lib__Debug_dump_event_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_Event__Lib__Debug_dump_event_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Event::Lib::Debug::dump_event_count", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1007 "Lib.xs"
{
    PerlIO_printf(PerlIO_stderr(), "%i: fh:%i signal:%i timer:%i\n", getpid(), 
				   EVENT_NEW_COUNT, SIGNAL_NEW_COUNT, TIMER_NEW_COUNT);
}
#line 1762 "Lib.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Event__Lib); /* prototype to pass -Wmissing-prototypes */
XS(boot_Event__Lib)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Event::Lib::constant", XS_Event__Lib_constant, file);
        newXS("Event::Lib::_default_callback", XS_Event__Lib__default_callback, file);
        newXSproto("Event::Lib::event_init", XS_Event__Lib_event_init, file, "");
        cv = newXS("Event::Lib::get_method", XS_Event__Lib_event_get_method, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Event::Lib::event_get_method", XS_Event__Lib_event_get_method, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Event::Lib::event_get_version", XS_Event__Lib_event_get_version, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Event::Lib::get_version", XS_Event__Lib_event_get_version, file);
        XSANY.any_i32 = 0 ;
        newXS("Event::Lib::event_log_level", XS_Event__Lib_event_log_level, file);
        newXS("Event::Lib::event_register_except_handler", XS_Event__Lib_event_register_except_handler, file);
        newXSproto("Event::Lib::event_priority_init", XS_Event__Lib_event_priority_init, file, "$");
        newXS("Event::Lib::event_new", XS_Event__Lib_event_new, file);
        newXS("Event::Lib::signal_new", XS_Event__Lib_signal_new, file);
        newXS("Event::Lib::timer_new", XS_Event__Lib_timer_new, file);
        newXS("Event::Lib::event_add", XS_Event__Lib_event_add, file);
        newXS("Event::Lib::event_free", XS_Event__Lib_event_free, file);
        newXSproto("Event::Lib::event_mainloop", XS_Event__Lib_event_mainloop, file, "");
        newXSproto("Event::Lib::event_one_loop", XS_Event__Lib_event_one_loop, file, ";$");
        newXSproto("Event::Lib::event_one_nbloop", XS_Event__Lib_event_one_nbloop, file, "");
        newXS("Event::Lib::base::remove", XS_Event__Lib__base_remove, file);
        newXS("Event::Lib::base::except_handler", XS_Event__Lib__base_except_handler, file);
        newXS("Event::Lib::base::callback", XS_Event__Lib__base_callback, file);
        newXS("Event::Lib::base::args", XS_Event__Lib__base_args, file);
        newXS("Event::Lib::base::args_del", XS_Event__Lib__base_args_del, file);
        newXS("Event::Lib::base::set_priority", XS_Event__Lib__base_set_priority, file);
        newXS("Event::Lib::base::trace", XS_Event__Lib__base_trace, file);
        newXS("Event::Lib::event::fh", XS_Event__Lib__event_fh, file);
        newXS("Event::Lib::event::pending", XS_Event__Lib__event_pending, file);
        newXS("Event::Lib::event::DESTROY", XS_Event__Lib__event_DESTROY, file);
        newXS("Event::Lib::signal::pending", XS_Event__Lib__signal_pending, file);
        newXS("Event::Lib::signal::remove", XS_Event__Lib__signal_remove, file);
        newXS("Event::Lib::signal::DESTROY", XS_Event__Lib__signal_DESTROY, file);
        newXS("Event::Lib::timer::pending", XS_Event__Lib__timer_pending, file);
        newXS("Event::Lib::timer::DESTROY", XS_Event__Lib__timer_DESTROY, file);
        newXS("Event::Lib::Debug::get_pending_events", XS_Event__Lib__Debug_get_pending_events, file);
        newXS("Event::Lib::Debug::dump_pending_events", XS_Event__Lib__Debug_dump_pending_events, file);
        newXS("Event::Lib::Debug::dump_allocated_events", XS_Event__Lib__Debug_dump_allocated_events, file);
        newXS("Event::Lib::Debug::dump_event_count", XS_Event__Lib__Debug_dump_event_count, file);
    }

    /* Initialisation Section */

#line 273 "Lib.xs"
{
    if (getenv("EVENT_LOG_LEVEL"))
	LOG_LEVEL = atoi(getenv("EVENT_LOG_LEVEL"));
#ifdef HAVE_LOG_CALLBACKS
    event_set_log_callback(log_cb);
#endif
    event_do_init();
    DEFAULT_EXCEPTION_HANDLER = newXS(NULL, XS_Event__Lib__default_callback, __FILE__);
}

#line 1843 "Lib.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

